/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eu.himeros.ocr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import org.apache.fop.hyphenation.Hyphenation;
import org.apache.fop.hyphenation.HyphenationTree;
import org.apache.fop.hyphenation.Hyphenator;

/**
 *
 * @author federico
 */
public class SyllableMaker{

	public SyllableMaker() {
		init();
	}

	public void init() {
	}

	public String eval(String text) {
		String res = null;
		return res;
	}

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) throws FileNotFoundException, IOException {
		BufferedReader dicBr = new BufferedReader(new FileReader("/home/federico/lab10/greek.dic"));
		BufferedReader br = new BufferedReader(new FileReader("/home/federico/lab10/greek.dic"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("/home/federico/lab10/t3.txt"));
		ArrayList<String> dicAL = new ArrayList<String>(1000000);
		ArrayList<String> syllAL = new ArrayList<String>(1000000);
		HashSet<String> hs=new HashSet<String>(100000);
		String line = null;
		HyphenationTree htree = Hyphenator.getUserHyphenationTree("el_EL", "/home/federico/lab10/hyph");
		Hyphenation hp = null;
		String s = null;
		try {
			int counter=0;
			while ((line = dicBr.readLine()) != null) {
				counter++;
				if(counter%10000==0){
					System.out.println(counter);
				}
				dicAL.add(line.replaceAll("_", ""));
				try {
					String[] items = line.split("[ ,.;\u0387]");
					for (int i = 0; i < items.length; i++) {
						hp = htree.hyphenate(items[i], 0, 0);
						int beg = 0;
						int end = items[i].length();
						int[] poss;
						if (hp == null) {
							poss = new int[1];
							poss[0] = end;
						} else {
							int[] ips = hp.getHyphenationPoints();
							poss = new int[ips.length + 1];
							System.arraycopy(ips, 0, poss, 0, ips.length);
							poss[poss.length - 1] = end;
						}
						int pos;
						String syll;
						for (int idx = 0; idx < poss.length; idx++) {
							if (idx < poss.length - 1) {
								pos = poss[idx]+1;						
								if(idx==0){syll="^";}else{syll="";};
								syll+=items[i].substring(beg, pos);
								hs.add(syll);
							} else {
								pos = poss[idx];
								syll="" +items[i].substring(beg, pos)+"#";
								hs.add(syll);
							}
							beg = poss[idx];
						}
					}
				} catch (Exception ex1) {
					ex1.printStackTrace();
					continue;
				}
			}
			System.out.println(hs.size());
			Iterator<String> it=hs.iterator();
			while(it.hasNext()){
				bw.write(it.next().replaceAll("_",""));
				bw.newLine();
			}
			bw.close();
		} catch (Exception ex) {
			ex.printStackTrace(System.err);
		}

	}
}
